WhatsApp Client Callback

Client Callback APIs allow you to receive real-time notifications (callbacks) for events that occur on your WhatsApp Business account. These callbacks are triggered by events that occur on the WhatsApp server, and are delivered to a URL that you specify in your webhook configuration.

For more information, see the Route Mobile WhatsApp OpenAPI Specifications.

Callback Error Codes

CodeTextDescription
400Media download errorThere was an error while downloading media.
401Group does not existThe specified group does not exist.
402OthersAn unspecified error occurred.
403Error code for blacklistingThe given number is blacklisted.
408Message is not validThe message is not valid or malformed.
410Message expiredThe message has expired and cannot be delivered.
429Rate limit hitThe rate limit for API calls has been reached.
430 - 433OthersUnspecified errors occurred.
470Re-engagement messageThe message is a re-engagement message.
471Spam Rate limitThe rate limit for sending spam messages has been reached.
472User's number is part of an experimentThe user's number is part of an experiment and cannot be used.
500Unknown ErrorAn unknown or unexpected error occurred.
1000OthersUnspecified errors occurred.
1001Message too longThe message exceeds the maximum length allowed.
1002Invalid recipient typeThe recipient type specified is not valid.
1003Not a group participantThe user is not a participant of the group.
1004Resource already existsThe resource being created already exists.
1005-1006OthersUnspecified errors occurred.
1008Required parameter is missingA required parameter for the API call is missing.
1009Parameter value is not validThe value provided for a parameter is not valid.
1010Parameter is not requiredA parameter that was provided is not required for the API call.
1011-1011OthersUnspecified errors occurred.
1012Group is unknownThe specified group is unknown.
1013User is not validThe specified user is not valid.
1014Corrupt ImageThe image provided is corrupt or invalid.
1015-1018OthersUnspecified errors occurred.
1019Not a group adminThe user is not an admin of the group.
1020Bad groupThe specified group is invalid or bad.
1021Bad UserThe specified user is invalid or bad.
1022-1024OthersUnspecified errors occurred.
1025Invalid RequestThe API request is invalid.
1026Receiver IncapableThe receiver is incapable of receiving the message.
2000Template Param Count MismatchThe number of parameters provided for a template does not match the required count.
2001Template MissingThe specified template does not exist.
2002Template Fetch FailedFailed to fetch the template.
2003Template Pack MissingThe template pack is missing.
2004Template Param Length Too LongThe length of a parameter in the template is too long.
2005Template Hydrated Text Too LongThe length of the hydrated text in the template is too long.
2006Template White Space Policy ViolatedThe template violates the white space policy.
2007Template Format Character Policy ViolatedThe template violates the format character policy.
2008Template Media Format UnsupportedThe media format in the template is unsupported.
2009Template Required Component MissingA required component in the template is missing.
2010Template Invalid Hydrated URLThe hydrated URL in the template is invalid.
2011Template Invalid Phone NumberThe phone number in the template is invalid.
2012Template Parameter Format MismatchThe format of a parameter in the template is mismatched.
2013Template Buttons UnsupportedThe buttons in the template are unsupported.
0AuthExceptionAn authentication exception occurred.
3API MethodAn error occurred with the API method.
10Permission DeniedThe user does not have the necessary permissions to perform the requested action.
190Access token has expiredThe access token used for authentication has expired.
200-299API PermissionThe API call requires specific permissions, and the user does not have them.
4API Too Many CallsThe API call limit has been exceeded.
80007Rate limit issuesThere are issues with the rate limits for API calls.
130429Rate limit hitThe rate limit for API calls has been reached.
131048Spam rate limit hitThe rate limit for sending spam messages has been reached.
131056(Business Account, Consumer Account) pair rate limit hitThe rate limit for a specific pair of business and consumer accounts has been reached.
368Temporarily blocked for policy violationsThe user or account has been temporarily blocked due to policy violations.
131031Account has been lockedThe user's account has been locked.
1API UnknownAn unknown error occurred with the API.
2API ServiceAn error occurred with the API service.
33Parameter value is not validThe value provided for a parameter is not valid.
100Invalid parameterThe parameter specified in the API call is invalid.
131000Something went wrongAn unspecified error occurred.
131005Access deniedAccess to the requested resource is denied.
131008Required parameter is missingA required parameter for the API call is missing.
131009Parameter value is not validThe value provided for a parameter is not valid.
131016Service unavailableThe requested service is currently unavailable.
131021Recipient cannot be senderThe recipient of the message cannot be the sender.
131026Message UndeliverableThe message could not be delivered to the recipient.
131042Business eligibility payment issueThere is an issue with the payment for business eligibility.
131045Incorrect certificateThe certificate used for authentication is incorrect.
131047Re-engagement messageThe message is a re-engagement message.
131051Unsupported message typeThe message type is not supported.
131052Media download errorThere was an error while downloading media.
131053Media upload errorThere was an error while uploading media.
132000Template Param Count MismatchThe number of parameters provided for a template does not match the required count.
132001Template does not existThe specified template does not exist.
132005Template Hydrated Text Too LongThe length of the hydrated text in the template is too long.
132007Template Format Character Policy ViolatedThe template violates the format character policy.
132012Template Parameter Format MismatchThe format of a parameter in the template is mismatched.
132015Template parameter invalidThe parameter in the template is invalid.
133000Incomplete DeregistrationThe deregistration process is incomplete.
133004Server Temporarily UnavailableThe server is temporarily unavailable.
133005Two-step verification PIN MismatchThe two-step verification PIN provided does not match.
133006Phone number re-verification neededPhone number re-verification is required.
133008Too Many two-step verification PIN GuessesToo many incorrect guesses for the two-step verification PIN.
133009Two-step verification PIN Guessed Too FastThe two-step verification PIN was guessed too quickly.
133010Phone number Not RegisteredThe phone number is not registered.
135000Generic user errorA generic error occurred for the user.

Template Status Logs

Template StatusLogs
Template Approved{"product": "whatsapp", "component": "whatsapp-callback-event-worker", "level": "debug", "timestamp": "2023-11-02 07:40:04.402735", "message": {"URL": "xxxxxxxxxxxxxxxxx", "data": {"statuses": [{"id": "xxxxxxxxxxxxxx", "template_name": "xxxxx", "template_id": xxxxxxxxxxxxxx, "template_language": "en", "reason": "NONE", "status": "APPROVED", "timestamp": xxxxxxxx, "type": "event", "information": null}], "brand_msisdn": "{phone}"}, "status": 200, "response_time": 0.0xxxxxxxxxxxxxx, "current_time": "xx:xx:xx.xxxxxx", "response": "{"success":true}"}}
Template Paused{"product": "whatsapp", "component": "whatsapp-callback-event-worker", "level": "debug", "timestamp": "2023-11-02 07:37:58.285408", "message": {"URL": "xxxxxxxxxxxxxxxxxxxxx", "data": {"statuses": [{"id": "xxxxxxxxxxxxxxx", "template_name": "abc__1", "template_id": xxxxxxxxxxxxxxx, "template_language": "en", "reason": "NONE", "status": "PAUSED", "timestamp": xxxxxxxxxx, "type": "event", "information": {"title": "FIRST_PAUSE", "description": "Your WhatsApp message template has been paused for x hours until xxx x at xx:xx AM UTC because it had issues."}}], "brand_msisdn": "{phone}"}, "status": 200, "response_time": 0.0xxxxxxxxxxxxxxx, "current_time": "xxxx-xx-xx xx:xx:xx.xxxxxx", "response": "{"success":true}"}}
Template Disabled{"product": "whatsapp", "component": "whatsapp-callback-event-worker", "level": "debug", "timestamp": "2023-11-02 09:57:45.920074", "message": {"URL": "xxxxxxxxxxxxxxxxxxxxxx", "data": {"statuses": [{"id": "xxxxxxxxxxxxxxxxx", "template_name": "xxxxxxxxxxxxxxx", "template_id": xxxxxxxxxxxxxx, "template_language": "en_US", "reason": "NONE", "status": "FLAGGED", "timestamp": xxxxxxxxxx, "type": "event", "information": null}], "brand_msisdn": "{phone}"}, "status": 200, "response_time": 0.011070728302001953, "current_time": "xxxx-xx-xx xx:xx:xx.xxxxxx", "response": "{"status":"ok"}\n"}}
Template Deleted{"product": "whatsapp", "component": "whatsapp-callback-event-worker", "level": "debug", "timestamp": "2023-11-02 10:36:44.798440", "message": {"URL": "xxxxxxxxxxxxxxxxxxxxxxxx", "data": {"statuses": [{"id": "xxxxxxxxxxxxxxxx", "template_name": "testing_02_2023", "template_id": xxxxxxxxxxxxxx, "template_language": "en_US", "reason": "NONE", "status": "PENDING_DELETION", "timestamp": xxxxxxxxxxx, "type": "event", "information": null}], "brand_msisdn": "{phone}"}, "status": 200, "response_time": 0.0xxxxxxxxxxxxxxxxxx, "current_time": "xxxx-xx-xx xx:xx:xx.xxxxxx", "response": "{"status":"ok"}\n"}}
Recent Requests
Log in to see full request history
TimeStatusUser Agent
Retrieving recent requests…
LoadingLoading…
Body Params

Webhook payload delivered by Route Mobile when events occur on your WhatsApp Business account.

messages
array of objects

An array of message objects that contains information about the incoming text message and its parameters.

messages
contacts
array of objects

An array of contact objects that contains information about the sender of the message and its parameters.

contacts
string

The phone number associated with the WhatsApp Business account in international format.

string

A unique ID for the callback request.

Headers
string
enum
Defaults to application/json

Generated from available request content types

Allowed:
Response
200

Success

Language
Credentials
Bearer
JWT
LoadingLoading…
Response
Click Try It! to start a request and see the response here!